// Seance 3bis.js
// appel des LEDS par variable

(function(ext) {
    var device = null;

	var levels = {
		HIGH:1,
		LOW:0
	};

	var LED = [0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09]; //Pin (en hexa) correspondant aux LEDs sur l'Arduino

    ext.resetAll = function(){
		for(var i = 1; i <= 7; i++) {
			runPackage(30, LED[i], levels.LOW); //Lorsqu'on reset, on éteint toutes les LEDs
		}
    };

	ext.RAZ = function(){
        runPackage(30, 0x02, 0); 	//Eteindre LED 2 à 9
		runPackage(30, 0x03, 0); 	
		runPackage(30, 0x04, 0); 	
		runPackage(30, 0x05, 0); 	
		runPackage(30, 0x06, 0); 	
		runPackage(30, 0x07, 0); 	
		runPackage(30, 0x08, 0); 	
		runPackage(30, 0x09, 0); 		
    };
	
	ext.runArduino = function(){
		responseValue();
	};
	
	ext.AL = function(i) {
        runPackage(30, i, 1); 	//Allumer LED i
    };
	
	ext.EL = function(i) {
        runPackage(30, i, 0); 	//éteindre LED i
    };
	
	/*function tempo(milliseconds) { //Permet d'attendre le nombre de milli secondes demandées
		var start = new Date().getTime();
		var t = milliseconds * 100; // passe en seconde
		for (var i = 0; i < 1e7; i++) {
			if ((new Date().getTime() - start) > t){
				break;
			}
		}
	};*/

	function sendPackage(argList, type){
		var bytes = [0xff, 0x55, 0, 0, type];
		for(var i=0;i<argList.length;++i){
			var val = argList[i];
			if(val.constructor == "[class Array]"){
				bytes = bytes.concat(val);
			}else{
				bytes.push(val);
			}
		}
		bytes[2] = bytes.length - 3;
		device.send(bytes);
	};

	function runPackage(){
		sendPackage(arguments, 2);
	};
	function getPackage(){
		var nextID = arguments[0];
		Array.prototype.shift.call(arguments);
		sendPackage(arguments, 1);
	};


    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    };

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    };

    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('arduino',processData);
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'Arduino disconnected'};
        if(watchdog) return {status: 1, msg: 'Probing for Arduino'};
        return {status: 2, msg: 'Arduino connected'};
    };

    var descriptor = {};
	ScratchExtensions.register('Seance 4bis', descriptor, ext, {type: 'serial'});
})({});
